
Lua_ChongzhiIosWindow = class("Lua_ChongzhiIosWindow", Lua_Window);
function Lua_ChongzhiIosWindow:ctor()
	self:superCall("ctor");
	self.showClose = false;
    self.windowName = "Lua_ChongzhiIosWindow";
end

function Lua_ChongzhiIosWindow:dispose()
	self:superCall("dispose");
end

function Lua_ChongzhiIosWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("SET_RECHARGE_DATA",self,self.setRechargeData);

    self.imgBg = UICreate.createImage(self.content, "", 0, 0, 0, 0);
    self.imgBg:setUrl("/images/chongzhi2/chongzhi_ios.png");
    self.imgBg:setDepth(-1);


 	self.closeLine = UICreate.createUIAtlasImage(self.content, "iconantlas1", "close_line", 0, 0, 22, 138);
	self.closeLine:setLocation(579, 228, 0);
	self.closeLine.depth = 2;

	self.btnClose = UICreate.createUIAtlasImage(self.content, "iconantlas1", "close_btn", 0, 0, 46, 46);
	self.btnClose.depth = 3;
	self.btnClose:setLocation(579, 255, 0);

    self.rechargeDragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 1060, 450));
	self.rechargeDragList:setLocation(0, -25, 0);
	self.rechargeDragList:setListCell(ChongzhiIosItem, 350, 264, 100);

	self.btnClose:addClickFuntion(self, self.onBtnCloseClick);
	DataCenter.rechargeData.isIos = true;
	DataCenter.rechargeData:sGetRechargeInfo();
end

-- 更新背包数据
function Lua_ChongzhiIosWindow:setRechargeData()
  	local tarr =DataCenter.rechargeData:rechargeInfoArr();
   	self.rechargeList=Array();
   	for i=1,tarr:getSize() do
	  	local info={}
	  	info.data=tarr[i];
	  	info.index=i;
	  	self.rechargeList:add(info);
   	end
   	self.rechargeDragList:setLuaArrayData(self.rechargeList, false);
end


function Lua_ChongzhiIosWindow:onBtnCloseClick(go)
	self:hide();
	Lua_WindowUtil.openWin("Lua_DragDownWindow", WinParam.ACTION_CLOSE, nil);
	Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_CLOSE, nil);
end





















ChongzhiIosItem = class("ChongzhiIosItem", Lua_ListCell);
function ChongzhiIosItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function ChongzhiIosItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content,"","",0,0,0,0);
    self.bg:setDepth(6);

    self.subButton = UICreate.createUIAtlasImage(self.content,"chongzhiWindow5","recharge_button",0,-223,0,0);
    self.subButton:setDepth(7);
    self.subButton:addClickFuntion(self, self.onSubClick);

	self.descTxt = UICreate.createLabel(self.content, "", 0, 0, 175, 70, 50);
    self.descTxt.pivot = UIWidget.Pivot.Center;
    self.descTxt:setDepth(10);
    self.descTxt.clickScale = false;
    self.descTxt:setLocation(0, -225, 0);
end

function ChongzhiIosItem:setData(data)
	self.data = data.data;
	if data.index < 5 then
		self.bg:setAltas("chongzhiWindow5", "recharge_gold"..data.index);
	else
		self.bg:setAltas("chongzhiWindow5", "recharge_gold4");
	end
	local str = "";
	str = tostring(math.floor(self.data.money));
    self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121317),str);
end

function ChongzhiIosItem:onSubClick() -- 确认
	local rd = DataCenter.roleData;
	if rd.limit == 1 then
		OperateAlert.show(LanUtil.getValue(122592));
		return;
	end
	DataCenter.sdkInterface:PointOut(tonumber(self.data.glodNum), tonumber(self.data.money))
end

function ChongzhiIosItem:dispose()
	self:superCall("dispose");
end