Lua_DailyRewardItem = class("Lua_DailyRewardItem", Lua_ListCell);
function Lua_DailyRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DailyRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(10)
	self.itemImage:setCanClick(false);
end

function Lua_DailyRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.id,data.amount,data.bind);
	tvo:fromServer(data);
	tvo.packType = Lua_PackTypeDefine.EQUIP;
	self.itemImage.data = tvo;
end

function Lua_DailyRewardItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.itemImage.item_bg.width;
	local height = self.itemImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	self.itemImage:showRoundEff(showRect:containeRect(rect));
end

function Lua_DailyRewardItem:onPlayerSoundClick(go) 
	if self.itemImage._data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImage._data, false);
	elseif self.itemImage.setOutputId ~= nil then
		Lua_WindowUtil.openWin("Lua_OutputWindow", nil, self.itemImage.setOutputId);
	end
end

function Lua_DailyRewardItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end