checkRequire("Lua_RechargeUtil");
checkRequire("Lua_RewardsUtil");
Lua_FristRechargeTipsWindow = class("Lua_FristRechargeTipsWindow", Lua_Window);
function Lua_FristRechargeTipsWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_FristRechargeTipsWindow";
	self.skinName = "FristRechargeTipsWindow_skin";
    self.showBg = false;
	self.showClose = false;
    self.isClickClose = true;
    self.isModel = false;
    self.blackAlpha = 1 / 255;
    self.layer = MainWinDefine.NEW_TIPS_LAYER;
end
function Lua_FristRechargeTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.chargeBtn:addClickFuntion(self,self.onChargeBtnClick);
    Lua_CommonUtil.addTimer("etimeStr_Timer",1,self,self.onTimeTimer,nil,-1);
    Lua_CommonUtil.addTimer("setWindowPosition",0.1,self,self.onSetPosition,nil,-1);
    self.eTimeNum=Lua_CommonUtil.getCommonConfig("sr_appear_small_open_time", 1)

    self.fightNum = Lua_NumberImage.new(self.fightingObj.gameObject);
	self.fightNum.prefix = "a_";
    self.fightNum.numWidth = 23;
    self.fightNum:setScale(0.7,0.7)
	self.fightNum:setDepth(10);
    self.fightNum:setLocation(0, 0, 0);

    -- self.content.transform.localPosition = Vector3(MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.offsetHeight-6, 0);
    LuaUtil.setObjPos(self.content, MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.offsetHeight-6, 0);
    self.highNum=self.offsetHeight-6;
    self.judgeNum=self.offsetHeight;


    self.buttonEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
    self.buttonEffect:SetRenderQueue(self.text3, 10, 2);
    local buttonConfig=Lua_RechargeUtil.getTipsWeaponStr(4)
    self.buttonData = Lua_RechargeUtil.getRechargeInfoByPlayerHanger(buttonConfig);
    self.buttonEffect:setUrl(self.buttonData.floder.."/"..self.buttonData.fileName,self.buttonData.fileName);
    self.buttonEffect:setSacle(self.buttonData.wingSca[1],self.buttonData.wingSca[2],self.buttonData.wingSca[3]);
    self.buttonEffect:setLocation(self.buttonData.wingPos[1],self.buttonData.wingPos[2],self.buttonData.wingPos[3]);
    
    local careernum = DataCenter.roleData.career;
    local weaponConfig = Lua_RechargeUtil.getTipsWeaponStr(careernum)

    self.weaponEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
    self.weaponEffect:SetRenderQueue(self.text3, 10, 2);
    self.weaponData = Lua_RechargeUtil.getRechargeInfoByPlayerHanger(weaponConfig);
    self.weaponEffect:setUrl(self.weaponData.floder.."/"..self.weaponData.fileName, self.weaponData.fileName);
    self.weaponEffect:setSacle(self.weaponData.wingSca[1], self.weaponData.wingSca[2], self.weaponData.wingSca[3]);
    self.weaponEffect:setLocation(self.weaponData.wingPos[1], self.weaponData.wingPos[2], self.weaponData.wingPos[3]);
    self.weaponEffect:setRot(self.weaponData.wingRot[1], self.weaponData.wingRot[2], self.weaponData.wingRot[3]);

    local weaponId = Lua_RechargeUtil.getRewardWeaponId(careernum)
    local rewardId=Lua_RechargeUtil.getDisplayReward(careernum)
    local rewardConfig = Lua_RewardsUtil.getRewardList(rewardId)
    local len=rewardConfig.rewardsVoArr:getSize();
    for i=1,len do
        if rewardConfig.rewardsVoArr[i].id==weaponId then
            self.fightNum.num = rewardConfig.rewardsVoArr[i].force;
        end
    end
end
function Lua_FristRechargeTipsWindow:onTimeTimer()
    self.eTimeNum=self.eTimeNum-1;
    if self.eTimeNum<=0 then
        self:hide();
        Lua_CommonUtil.removeTimer(self, self.onTimeTimer);
	end
end
function Lua_FristRechargeTipsWindow:onSetPosition()
    if self.judgeNum<=self.highNum then
        self.judgeNum=self.offsetHeight-6;
        self.highNum=self.highNum-1;
        -- self.content.transform.localPosition = Vector3(MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.highNum, 0);
        LuaUtil.setObjPos(self.content, MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.highNum, 0);
    elseif self.judgeNum>self.highNum then
        self.judgeNum=self.offsetHeight+6;
        self.highNum=self.highNum+1;
        -- self.content.transform.localPosition = Vector3(MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.highNum, 0);
        LuaUtil.setObjPos(self.content, MainWinDefine.V_width / 2 + self.offsetWidth, MainWinDefine.V_height / 2+self.highNum, 0);
    end
end
function Lua_FristRechargeTipsWindow:onChargeBtnClick()
    Lua_MsgUtil.callFunc("OPEN_FACTION_FRISTRECHARGE");
    self:hide();
    -- Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 1);
end
function Lua_FristRechargeTipsWindow:dispose()
	self:superCall("dispose");
    Lua_CommonUtil.removeTimer(self, self.onTimeTimer);
    Lua_CommonUtil.removeTimer(self, self.onSetPosition);
    if self.buttonEffect ~= nil then
        self.buttonEffect:dispose();
    end
    if self.weaponEffect ~= nil then
        self.weaponEffect:dispose();
    end
end
function Lua_FristRechargeTipsWindow.Get:offsetWidth()
    return -660;
end
function Lua_FristRechargeTipsWindow.Get:offsetHeight()
    return -515;
end