checkRequire("Lua_RechargeUtil")
checkRequire("Lua_RewardsUtil");
Lua_FristRechargeWindow = class("Lua_FristRechargeWindow", Lua_Window);
function Lua_FristRechargeWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_FristRechargeWindow";
	self.skinName = "FristRechargeWindow_skin";
end

function Lua_FristRechargeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.chargeBtn:addClickFuntion(self,self.onChargeBtnClick);
    self:addLuaEvent("SET_FRISTRECHARGE_BTN",self,self.setFristRechargeBtn);
    self.chargeBtn:SetDimensions(339,60);
    self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:buildShowItem();
    self.rItem:setLayout(80, 80, 6);
	self.rItem:setMaxShow(6);
	self.rItem:setDepth(self.depth+10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.9,0.9);
    self.rItem:setLocation(-203,-125, 0);

    --首充红点
    self.redDot = UICreate.createUIAtlasImage(self.content,"common_atlas_1","ui_common_hongdian",123,-203,0,0)
    self.redDot:setDepth(6);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
    local isShow = DataCenter.redDotData:getRedDotStateByEventId(11173);
	self.redDot:setEnable(isShow);

    local careernum = DataCenter.roleData.career;
    local leftEffectConfig=Lua_RechargeUtil.getLeftEffectStr(careernum)
    local rightEffectConfig=Lua_RechargeUtil.getRightEffectStr(careernum)

    self.effectConfig=Lua_RechargeUtil.getPropArr();
    self.effectConfig:add(leftEffectConfig);
    self.effectConfig:add(rightEffectConfig);
    self.effectArr=Array()

    for i=1,self.effectConfig:getSize() do
        local effectData = Lua_RechargeUtil.getRechargeInfoByPlayerHanger(self.effectConfig[i]);
        self.effect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
        self.effect:SetRenderQueue(self.text5, 5, 2,true);
        self.effect:setUrl(effectData.floder.."/"..effectData.fileName, effectData.fileName);
        self.effect:setSacle(effectData.wingSca[1], effectData.wingSca[2], effectData.wingSca[3]);
        self.effect:setLocation(effectData.wingPos[1], effectData.wingPos[2], effectData.wingPos[3]);
        if effectData.wingRot ~= nil then
            self.effect:setRot(effectData.wingRot[1], effectData.wingRot[2], effectData.wingRot[3]);
        end
        self.effectArr:add(self.effect);
    end

    self.fightRightNum = Lua_NumberImage.new(self.right_fightingObj.gameObject);
    self.fightRightNum.numWidth = 12;
    self.fightRightNum.prefix = "ui_first_recharge_font_zdl";
    self.fightRightNum:setScale(1,1)
    self.fightRightNum:setDepth(10);
    self.fightRightNum:setLocation(0, 16, 0);

    self.fightLeftNum = Lua_NumberImage.new(self.left_fightingObj.gameObject);
    self.fightLeftNum.numWidth = 12;
    self.fightLeftNum.prefix = "ui_first_recharge_font_zdl";
    self.fightLeftNum:setScale(1,1)
    self.fightLeftNum:setDepth(10);
    self.fightLeftNum:setLocation(0, 16, 0);


    local leftFight=Lua_CommonUtil.getCommonConfig("sr_appear_fashion_fight", 1)
    self.fightLeftNum.num = leftFight;

    local weaponId = Lua_RechargeUtil.getRewardWeaponId(careernum)
    local rewardId = Lua_RechargeUtil.getDisplayReward(careernum)
    self.rItem:setRewardByRewardList(Array(rewardId));
    local rewardConfig = Lua_RewardsUtil.getRewardList(rewardId)
    local len=rewardConfig.rewardsVoArr:getSize();
    for i=1,len do
        if rewardConfig.rewardsVoArr[i].id==weaponId then
            self.fightRightNum.num = rewardConfig.rewardsVoArr[i].force;
        end
    end

    --关闭首充tips
    if Lua_WindowUtil.isWindowShowing("Lua_FristRechargeTipsWindow") == true then
        Lua_WindowUtil.openWin("Lua_FristRechargeTipsWindow",WinParam.ACTION_CLOSE,nil);
    end

    DataCenter.rechargeData:sGetRechargeInfo();
end
function Lua_FristRechargeWindow:onChargeBtnClick()
    self:hide();
    Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 1);
end
function Lua_FristRechargeWindow:setFristRechargeBtn()
    if DataCenter.rechargeData.recharge_reward==2 then
        self.btnTxt:setAltas("firstReCharge_atlas", "ui_first_recharge_font_7");
        self.chargeBtn:removeClickFuntion(self,self.onChargeBtnClick);
        self.chargeBtn:addClickFuntion(self,self.onReceiveClick);
    end
end
function Lua_FristRechargeWindow:onReceiveClick()
    self:hide();
    DataCenter.rechargeData:sReceiveFirstReward();
end
function Lua_FristRechargeWindow:dispose()
	if self.playerModel1 ~= nil then
		self.playerModel1:dispose();
    end
    if self.playerModel2 ~= nil then
		self.playerModel2:dispose();
	end
    for i=1,self.effectArr:getSize() do
        self.effectArr[i]:dispose();
    end
    self.effectConfig=nil;
	self:superCall("dispose");
end