Lua_InvestmentPlanPanel = class("Lua_InvestmentPlanPanel", Lua_DisplayObject);
function Lua_InvestmentPlanPanel:ctor(p)
	self:superCall("ctor", p, "InvestmentPlan_skin");
end

function Lua_InvestmentPlanPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_MsgUtil.callFunc("CHONGZHI_REDDOT_POS", 10083);

	self.isMoveTo = true;

	self.moneyConfig = DataCenter.investmentPlanData:getMoneyList();
	self.moneyList = {};
	for i = 2, #self.moneyConfig do
		self.moneyList[i - 1] = self.moneyConfig[i];
	end

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 977, 379));
	self.rewardList:setLocation(104, -114, 0);
	self.rewardList:setListCell(Lua_InvestmentPlanItem, 129, 977, 1);

	self.describeText.clickScale = false;
	self.AlertTipsTxt.text = LanUtil.getValue(122526);
	self.selectBtn:addClickFuntion(self, self.onMoneySelect);
	self.ruleSp:addClickFuntion(self, self.onRuleSpClick);
	self.describeText:addClickFuntion(self, self.onClickTxt);
	self.investmentBtn:addClickFuntion(self, self.onInvestmenting);

	self:addLuaEvent("rSetInvestmentPlanData", self, self.rSetInvestmentPlanData);
	if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
		DataCenter.investmentPlanData:sGetPeakInvestmentInfo(0);
	else
		DataCenter.investmentPlanData:sGetInvestmentPlanInfo(0);
	end
end

function Lua_InvestmentPlanPanel:rSetInvestmentPlanData()
	if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
		self.artText:setAltas("recharge_atlas", "ui_chongzhi_z_12");
	else
		self.artText:setAltas("recharge_atlas", "ui_chongzhi_z_21");
	end

	self.goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	self.copperNum = DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);

	self.tarr = DataCenter.investmentPlanData.investmentInfoArr;
	self.rewardList:setLuaArrayData(self.tarr, false);
	for i = 1, self.tarr:getSize() do
		if self.tarr[i].status == 1 and self.isMoveTo then
			self.rewardList:moveToIndex(self.tarr[i].index);
			self.isMoveTo = false;
		end
	end

	self.currentGrade = DataCenter.investmentPlanData.currentGrade;
	self.moneyTextInput.text = self.moneyList[self.currentGrade];

	self.oldGrade = DataCenter.investmentPlanData.oldGrade;
	self.investmentBtn:setBtnEnable(self.currentGrade > self.oldGrade or self.oldGrade == 0);

	if self.oldGrade ~= 0 and self.oldGrade ~= #self.moneyList then
		if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
			self.describeText.text = LanUtil.formateStr(LanUtil.getValue(122524), tostring(self.moneyList[self.oldGrade]), "15");
		else
			self.describeText.text = LanUtil.formateStr(LanUtil.getValue(122524), tostring(self.moneyList[self.oldGrade]), "10");
		end
	elseif self.oldGrade ~= 0 and self.oldGrade == #self.moneyList then
		self.describeText.text = LanUtil.getValue(122525);
	elseif self.oldGrade == 0 then
		if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
			self.describeText.text = LanUtil.formateStr(LanUtil.getValue(122523), tostring(self.moneyList[self.currentGrade]), "15", tostring(DataCenter.investmentPlanData.getLabelId));
		else
			self.describeText.text = LanUtil.formateStr(LanUtil.getValue(122523), tostring(self.moneyList[self.currentGrade]), "10", tostring(DataCenter.investmentPlanData.getLabelId));
		end
	end
    self:showEffect(self.oldGrade < DataCenter.investmentPlanData.getMaxInvestGrade);
end

function Lua_InvestmentPlanPanel:showEffect(val)
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if val then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/tx_chose", "tx_chose", 261, 229.5);
		self.rsEffect:SetRenderQueue(self.topBg, 12, 2, false);
	else
		if self.rsEffect ~= nil then
			self.rsEffect:dispose();
			self.rsEffect = nil;
		end
	end
end

function Lua_InvestmentPlanPanel:onMoneySelect()
	local dragData = {};
	dragData.datas = Array();
	for i = 1, #self.moneyList do
		dragData.datas:add(self.moneyList[i]);
	end
	dragData.offsetX = 138;
	dragData.offsetY = 124.5;
	dragData.width = 195;
	dragData.height = 167;
	dragData.rowSpacing = 44;
	dragData.callBackOwner = self;
	dragData.callBack = self.onMoneyDragDownCallBack;
	dragData.selected = self.moneyType;
	dragData.bgAltas = "common_atlas_1";
	dragData.bgSprite = "ui_common_widget_01"
	dragData.itemBgAltas = "common_atlas_1"
	dragData.itemNotSelectSprite = "ui_common_btn_13"
	dragData.itemSelectSprite = "ui_common_btn_8"
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_InvestmentPlanPanel:onMoneyDragDownCallBack(val)
	self:setMoneyType(val);
end

function Lua_InvestmentPlanPanel:setMoneyType(val)
	self.moneyType = val
	self.moneyTextInput.text = self.moneyList[val];
	if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
		DataCenter.investmentPlanData:sGetPeakInvestmentInfo(val);
	else
		DataCenter.investmentPlanData:sGetInvestmentPlanInfo(val);
	end
end

function Lua_InvestmentPlanPanel:onRuleSpClick()
	Lua_WindowUtil.openWin("Lua_InvestmentPlanRuleWindow")
end

function Lua_InvestmentPlanPanel:onClickTxt(go)
	local urlStr = self.describeText:getUrlByMousePos();
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		local itemId = tonumber(arr[2]);
		local tvo = Lua_ToolVo.createToolVo(itemId);
		Lua_PackUtil.showItemInfo(tvo, false);
	end
end

function Lua_InvestmentPlanPanel:onInvestmenting()
	if self.oldGrade == 0 then
		if self.goldNum < self.moneyList[self.currentGrade] then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
		else
			if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
				DataCenter.investmentPlanData:sPeakInvestmenting(self.currentGrade);
			else
				DataCenter.investmentPlanData:sInvestmenting(self.currentGrade);
			end
		end
	else
		if self.goldNum < (self.moneyList[self.currentGrade] - self.moneyList[self.oldGrade]) then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
		elseif self.goldNum >= (self.moneyList[self.currentGrade] - self.moneyList[self.oldGrade]) and (self.currentGrade - self.oldGrade) > 0 then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, subFun = self.investmenging,
			des = LanUtil.formateStr(LanUtil.getValue(122522), tostring(self.moneyList[self.currentGrade] - self.moneyList[self.oldGrade]),
				tostring(self.moneyList[self.currentGrade]))});
		end
	end
end

function Lua_InvestmentPlanPanel:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_InvestmentPlanPanel:investmenging()
	if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
		DataCenter.investmentPlanData:sPeakInvestmenting(self.currentGrade);
	else
		DataCenter.investmentPlanData:sInvestmenting(self.currentGrade);
	end
end

function Lua_InvestmentPlanPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_InvestmentPlanItem = class("Lua_InvestmentPlanItem", Lua_ListCell);
function Lua_InvestmentPlanItem:ctor(p)
	self:superCall("ctor", p, "InvestmentPlanItem_skin");
end

function Lua_InvestmentPlanItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(6);
	self.rItem:setLayout(90, 90, 6);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(-439, 11.5, 0);

	self.receiveBtn:addClickFuntion(self, self.onReceiveReward);
end

function Lua_InvestmentPlanItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.confingData.cash_gift ~= nil then
		local len = #data.confingData.cash_gift;
		if DataCenter.investmentPlanData.currentGrade ~= 3 then
			if len == 2 then
				len = len - 1;
			end
		end

		local tvo;
		local rewardArr = Array();
		for i = 1, len do
			tvo = Lua_ToolVo.createToolVo(data.confingData.cash_gift[i][1])
			tvo.packType = 999;
			rewardArr:add(tvo);
		end
		self.rItem:setRewardByArray(rewardArr);
	end

	if tonumber(data.confingData.limit_lv) ~= 0 then
		self.desLab.text = LanUtil.formateStr(LanUtil.getValue(122518), tostring(data.confingData.limit_lv), tostring(data.confingData.reward_rate))
	else
		self.desLab.text = LanUtil.formateStr(LanUtil.getValue(122517), tostring(data.confingData.reward_rate))
	end
	self.drawMoneyLab.text = data.reward;

	local rewardMultiple = tonumber(data.confingData.reward_multiple)
	if rewardMultiple ~= nil and rewardMultiple == -1 then
		-- 第一个档次显示称号
		local titleId = getConfig({"item", DataCenter.investmentPlanData.getLabelId, "effect_prop"}).label_id;
		if self.titleIcon == nil then
			self.titleIcon = UICreate.createUIAtlasImage(self.content, "item7", tostring(titleId), 108, 13.5, 0, 0);
			self.titleIcon.clickScale = false;
			self.titleIcon.name = "titleIcon";
			self.titleIcon:setDepth(10);
			self.titleIcon:addClickFuntion(self, self.onTitleClick)
		end
		self.titleIcon:setEnable(true);
	else
		if self.titleIcon ~= nil then
			self.titleIcon:setEnable(false);
		end
	end

	if rewardMultiple ~= 0 and rewardMultiple ~= -1 then
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122519), tostring(data.confingData.reward_multiple))
	end
	self.tipsLab:setEnable(rewardMultiple ~= 0 and rewardMultiple ~= -1);
	self.tipsIcon:setEnable(rewardMultiple == -1);

	if tonumber(data.status) == 2 and self.oldGrade == self.currentGrade then
		self.receiveBtn.label = LanUtil.getValue(122528)
	else
		self.receiveBtn.label = LanUtil.getValue(122527)
	end
	self.receiveBtn:setBtnEnable(tonumber(data.status) == 1 and self.oldGrade == self.currentGrade);
	self.redDot:setEnable(tonumber(data.status) == 1 and self.oldGrade == self.currentGrade);
end

function Lua_InvestmentPlanItem:onReceiveReward()
	if DataCenter.investmentPlanData.peakInvestmentOpen ~= nil and DataCenter.investmentPlanData.peakInvestmentOpen == 1 then
		DataCenter.investmentPlanData:sReceivePeakInvestmentInfo(self._data.index);
	else
		DataCenter.investmentPlanData:sReceiveInvestmentPlanInfo(self._data.index);
	end
end

function Lua_InvestmentPlanItem:onTitleClick()
	local vo = Lua_ToolVo.createToolVo(tonumber(DataCenter.investmentPlanData.getLabelId));
	Lua_PackUtil.showItemInfo(vo, false);
end

function Lua_InvestmentPlanItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end