Lua_MagicBagTipsWindow = class("Lua_MagicBagTipsWindow", Lua_ThirdSizeWindow);
function Lua_MagicBagTipsWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_MagicBagTipsWindow";
    self.skinName = "magicBagTipsWindow_skin";
    self.w = 600;
    self.h = 408;
    self.titleText = "寶箱詳情"
end

function Lua_MagicBagTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.winBg:SetDimensions(604, 332);

    -- 奖励展示
    local rewardId = 10042;

    self.dragList = Lua_DragList.new(self.content, 2, Vector4(43, -63, 400, 90));
    self.dragList:setLocation(-36.5, 66, 0);
    self.dragList:setListCell(Lua_MagicBagTipsItem, 90, 99, 8);
    self.dragList:setLuaArrayData(DataCenter.rechargeData.magicBagGiftData, false);
    self.tipsTxt.text = LanUtil.getValue(122590);
    self.subBtn:addClickFuntion(self, self.onSubClick);
end

function Lua_MagicBagTipsWindow:showWin(param)
    self.param = param;

end

function Lua_MagicBagTipsWindow:onSubClick()
    local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneConfig.kuafu_map == 1 then
        DataCenter.moneyData:kuaFuLimit();
    else
        DataCenter.sdkInterface:PointOut(0, tonumber(self.param), DataCenter.rechargeData.magicRechargeId);
    end
    
    Lua_WindowUtil.openWin("Lua_MagicBagTipsWindow", WinParam.ACTION_CLOSE);
end

function Lua_MagicBagTipsWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose()
        self.dragList = nil;
    end
    self:superCall("dispose");
end














Lua_MagicBagTipsItem = class("Lua_MagicBagTipsItem", Lua_ListCell);
function Lua_MagicBagTipsItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_MagicBagTipsItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setLocation(0,0,0)
        self.itemImage:setDepth(10);
        self.itemImage:setCanClick(false);
    end
end

function Lua_MagicBagTipsItem:setData(data)
    self.data = data;
    self.tvo = Lua_ToolVo.createToolVo(data.id,data.count,data.bind);
    self.itemImage.data = self.tvo;
end

function Lua_MagicBagTipsItem:onPlayerSoundClick(go)
    if self.data ~= nil then
        Lua_PackUtil.showItemInfo(self.tvo);
    end
end

function Lua_MagicBagTipsItem:dispose()
    self:superCall("dispose");
end
