Lua_MonthlyPlanPanel = class("Lua_MonthlyPlanPanel", Lua_DisplayObject);
function Lua_MonthlyPlanPanel:ctor(p)
	self:superCall("ctor", p, "MonthlyPlan_skin");
end

function Lua_MonthlyPlanPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_MsgUtil.callFunc("CHONGZHI_REDDOT_POS", 10084);

	self.isMoveTo = true;

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 977, 379));
	self.rewardList:setLocation(104, -114, 0);
	self.rewardList:setListCell(Lua_MonthlyPlanItem, 129, 977, 1);

	self.moneyNum = DataCenter.monthlyPlanData:getInvestMoney();
	self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(122529), tostring(self.moneyNum));
	self.tipsLab.text = LanUtil.getValue(122526);

	local tvo;
	local itemImg;
	self.propArr = DataCenter.monthlyPlanData:getPropId()
	for i = 1, #self.propArr do
		tvo = Lua_ToolVo.createToolVo(self.propArr[i]);
		tvo.bShowItemBg = false;

		itemImg = Lua_ToolImage.new(self.content);
		itemImg.data = tvo;
		itemImg:setDepth(5);
		itemImg:setLocation(87 + (i - 1) * 94, 195, 0);
	end

	self.investmentBtn:addClickFuntion(self, self.onInvestmenting);

	self:addLuaEvent("rUpadteMonthlyPlanData", self, self.rUpadteMonthlyPlanData);
	DataCenter.monthlyPlanData:sGetMonthlyPlanInfo();
end

function Lua_MonthlyPlanPanel:rUpadteMonthlyPlanData()
	self.goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	self.copperNum = DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);

	if DataCenter.monthlyPlanData.is_invest == 0 then
		local ProfitNum = DataCenter.monthlyPlanData:getProfitMultiplier();
		self.investmentBtn:setBtnEnable(true);
		self.investmentBtn.fontSize = 22;
		self.investmentBtn.label=LanUtil.formateStr(LanUtil.getValue(122530), tostring(self.moneyNum), tostring(ProfitNum));
	else
		self.investmentBtn:setBtnEnable(false);
		self.investmentBtn.fontSize = 26;
		self.investmentBtn.label=LanUtil.getValue(122533);
	end

	local arr = DataCenter.monthlyPlanData.monthlyPlanList;
	self.rewardList:setLuaArrayData(arr, false);

	for i = 1, arr:getSize() do
		if arr[i].status == 1 and self.isMoveTo then
			self.rewardList:moveToIndex(arr[i].index);
			self.isMoveTo = false;
		end
	end
end

function Lua_MonthlyPlanPanel:onInvestmenting()
	if self.goldNum < tonumber(DataCenter.monthlyPlanData:getInvestMoney()) then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521),
			type = 1, subFun = self.openChargeWin});
	else
		DataCenter.monthlyPlanData:sSetImmediateInvestment();
	end
end

function Lua_MonthlyPlanPanel:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_MonthlyPlanPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MonthlyPlanItem = class("Lua_MonthlyPlanItem", Lua_ListCell);
function Lua_MonthlyPlanItem:ctor(p)
	self:superCall("ctor", p, "MonthlyPlanItem_skin");
end

function Lua_MonthlyPlanItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(6);
	self.rItem:setLayout(90, 90, 6);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(-439, 11.5, 0);

	self.receiveBtn:addClickFuntion(self, self.onReceiveClick);
end

function Lua_MonthlyPlanItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.cash_gift ~= nil then
		local len = #data.cash_gift;
		if DataCenter.monthlyPlanData.reward_limit == 1 then 
			if DataCenter.monthlyPlanData.is_first == 1 then
				if len == 2 then
					len = len - 1;
				end
			end
		end

		local tvo;
		local rewardArr = Array();
		for i = 1, len do
			tvo  = Lua_ToolVo.createToolVo(data.cash_gift[i][1]);
			tvo.packType = 999;
			rewardArr:add(tvo);
		end
		self.rItem:setRewardByArray(rewardArr);
	end

	if tonumber(data.date) == 0 then
		self.desLab.text = LanUtil.getValue(122531);
	else
		self.desLab.text = LanUtil.formateStr(LanUtil.getValue(122532), tostring(data.date))
	end
	self.drawMoneyLab.text = data.reward;

	if tonumber(data.multipleConfing) ~= 0 and tonumber(data.multipleConfing) ~= -1 then
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122519), tostring(data.multipleConfing));
	end
	self.tipsLab:setEnable(tonumber(data.multipleConfing) ~= 0 and tonumber(data.multipleConfing) ~= -1);
	self.tipsIcon:setEnable(tonumber(data.multipleConfing) == -1);

	if data.status == 0 then
		self.receiveBtn.label = LanUtil.getValue(122527);
	elseif data.status == 1 then
		self.receiveBtn.label = LanUtil.getValue(122527);
	elseif data.status == 2 then
		self.receiveBtn.label = LanUtil.getValue(122528);
	end
	self.receiveBtn:setBtnEnable(data.status == 1);
	self.redDot:setEnable(data.status == 1);
end

function Lua_MonthlyPlanItem:onReceiveClick()
    DataCenter.monthlyPlanData:sReceiveMonthlyPlanInfo(self._data.index);
end

function Lua_MonthlyPlanItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end