checkRequire("Lua_RechargeUtil")
checkRequire("Lua_RewardsUtil");
checkRequire("Lua_MyPlayerModel");
Lua_NewFristRechargeWindow = class("Lua_NewFristRechargeWindow", Lua_Window);
function Lua_NewFristRechargeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewFristRechargeWindow";
	self.skinName = "NewFristRechargeWindow_skin";
end

function Lua_NewFristRechargeWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	local cell;
	self.cellList = 3;
	self.cellListArr = Array();
	for i = 1, self.cellList do
		cell = Lua_NewFristRechargeCell.new(self.content);
		cell:setIndex(i);
		if i == 1 then
			cell.dayNumSp:setAltas("newFirstReCharge_atlas", "ui_newfirst_recharge_font_5");
		elseif i == 2 then
			cell.dayNumSp:setAltas("newFirstReCharge_atlas", "ui_newfirst_recharge_font_6");
		elseif i == 3 then
			cell.dayNumSp:setAltas("newFirstReCharge_atlas", "ui_newfirst_recharge_font_8");
		end
		cell:setLocation(404 - (i - 1) * 57, -72 - (i - 1) * 85, 0);
		self.cellListArr:add(cell);
	end

	self.rewardItem = Lua_RewardDragItem.new(self.content, 500, 80);
	self.rewardItem.pivot = 2;
	self.rewardItem:setDepth(5);
	self.rewardItem:setLocation(22, -97, 0);

	self.fightRightNum = Lua_NumberImage.new(self.content);
	self.fightRightNum.prefix = "ui_first_recharge_font_zdl";
	self.fightRightNum.numWidth = 13
	self.fightRightNum:setDepth(10);
	self.fightRightNum:setLocation(-377, -265, 0);

	self.chargeBtn:addClickFuntion(self, self.onChargeBtnClick);
	self.getBtn:addClickFuntion(self, self.onGetBtnClick);

	self:addLuaEvent("SET_SELECTED_BTN", self, self.selected);
	self:addLuaEvent("SET_FRISTRECHARGE_BTN", self, self.newFristRechargeInfo);
	DataCenter.rechargeData:sGetRechargeInfo();
end

function Lua_NewFristRechargeWindow:selected(index)
	if self.index ~= index then
		self:newFristRechargeInfo(index);
	end
end

function Lua_NewFristRechargeWindow:newFristRechargeInfo(index)
	local rechargeData = DataCenter.rechargeData;
	if index == nil then
		self.index = rechargeData.selectIndex;
	else
		self.index = index;
	end

	for i,v in ipairs(rechargeData.newRechargeDic) do
		self.cellListArr[i]:isSelecting(self.index == i);
		self.cellListArr[i]:setData(v.rewardStatus);

		if self.index == i and v.rewardStatus == 2 then -- 可领取
			self.chargeBtn:setEnable(false);
			self.chargeTxtSp:setEnable(false); -- 充值

			self.getBtn.mouseEnable = true;
			self.getBtn:setGray(false);
			self.getBtn:setEnable(true);
			self.getTxtSp:setEnable(true); -- 领取
			self.redDot:setEnable(true);
			
			self.alreadyReceived:setEnable(false); -- 已领取
		end

		if self.index == i and v.rewardStatus == 1 then -- 已领取
			self.chargeBtn:setEnable(false);
			self.chargeTxtSp:setEnable(false);

			self.getBtn:setEnable(false);
			self.getTxtSp:setEnable(false);
			self.redDot:setEnable(false);

			self.alreadyReceived:setEnable(true);
		end

		if self.index == i and v.rewardStatus == 0 then -- 不可领取
			self.chargeBtn:setEnable(false);
			self.chargeTxtSp:setEnable(false);

			self.getBtn.mouseEnable = false;
			self.getBtn:setGray(true);
			self.getBtn:setEnable(true);
			self.getTxtSp:setEnable(true);
			self.redDot:setEnable(false);

			self.alreadyReceived:setEnable(false);

			if rechargeData.recharge_reward == 0 then
				self.chargeBtn:setEnable(true);
				self.chargeTxtSp:setEnable(true);

				self.getBtn:setEnable(false);
				self.getTxtSp:setEnable(false);
			end
		end
	end

	local info = rechargeData.newRechargeDic[self.index]
	self.rewardItem:setRewardByArray(info.rewardConfig.rewardsVoArr);
	self.describeImg:setUrl(info.describe .. ".png");

	if self.index == 1 or self.index == 2 then
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
		if self.monsEffect ~= nil then
			self.monsEffect:dispose();
			self.monsEffect = nil;
		end

		self.modelPos = Vector3(info.config.new_pos[self.index][1], info.config.new_pos[self.index][2], info.config.new_pos[self.index][3]);
		self.modelRot = Vector3(0, 90, 0);
		self.modelSca = info.config.new_sca[self.index][1];
		
		local modelData = UsData();
		modelData.career = DataCenter.roleData.career;
		if modelData.career == 2 then
			modelData.gender = Lua_ThingDefine.FEMALE;
		else
			modelData.gender = Lua_ThingDefine.MALE;
		end

		if self.index == 2 then
			modelData.fashion_clothes_id = tostring(info.config.modelName[self.index - 1]);
			modelData.fashionHeadId = tostring(info.config.modelName[2]);
		else
			modelData.fashion_clothes_id = tostring(info.config.modelName[self.index]);
		end
		modelData.nickname = "";
		modelData.hp = 1;
		modelData.kind = 2;
		modelData.isShowName = false;
		modelData.IsUI = true;
		
		self:showFashionModel(modelData);
	else
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
		if self.monsEffect ~= nil then
			self.monsEffect:dispose();
			self.monsEffect = nil;
		end

		local imgPos = Vector3(info.config.new_pos[self.index][1], info.config.new_pos[self.index][2], info.config.new_pos[self.index][3]);
		local imgSize = Vector2(300, 400);
		local modelRot = Vector3(info.config.new_ros[self.index][1], info.config.new_ros[self.index][2], info.config.new_ros[self.index][3]);
		local modelOffset = Vector2(35, 0);
		
		if self.monsEffect == nil then
			self.monsEffect = UIModelTexture();
			self.monsEffect:init(self.content, imgPos, imgSize, 5, modelRot, modelOffset, info.config.new_sca[self.index][1]);
			self.monsEffect:setCamPos(0, -5000, 0);
			self.monsEffect:setCamView(7);
			self.monsEffect:setRotEnable(true, -0, 0, 300, 300, 2);
			self.monsEffect:setUrl(info.config.floderName[self.index], tostring(info.config.modelName[self.index]));
			LuaUtil.setObjRot(self.monsEffect.root, info.config.new_ros[self.index][1], info.config.new_ros[self.index][2], info.config.new_ros[self.index][3]);
			self.monsEffect:setEffectPos(-73, 0, 0);
			self.monsEffect.uiEffect:setRot(-90, 178, 0);
		end
	end
	self.fightRightNum.num = info.getForceNumber;
end

function Lua_NewFristRechargeWindow:showFashionModel(modelData)
	if modelData ~= nil then
		if self.playerModel == nil then
			self.playerModel = ModelPlayer();
		end
		self.playerModel:init(self.content, self.modelPos, self.modelRot, modelData, nil, self.modelSca);
		self.playerModel:setRotEnable(true, -2, 178, 300, 400, 2);
		self.playerModel:SetRenderQueue(self.modelPlatform, 5, 2);
	else
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
	end
end

function Lua_NewFristRechargeWindow:onChargeBtnClick()
	self:hide();
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_NewFristRechargeWindow:onGetBtnClick()
	if self.index == 1 then
		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.onFirstCharge);
	end
	
	local cmd = ProtoPublic_pb.Proto11401802();
	cmd.index = self.index - 1;
	sendMsg(11401802, cmd)
end

function Lua_NewFristRechargeWindow:dispose()
	if self.cellListArr ~= nil then
		self.cellListArr:dispose();
		self.cellListArr:clear();
		self.cellListArr = nil;
	end
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil
	end
	if self.fightRightNum ~= nil then
		self.fightRightNum:dispose();
		self.fightRightNum = nil
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewFristRechargeCell = class("Lua_NewFristRechargeCell", Lua_DisplayObject);
function Lua_NewFristRechargeCell:ctor(p)
	self:superCall("ctor", p, "NewFristRechargeCell_skin");
end

function Lua_NewFristRechargeCell:buildShowItem()
	self:superCall("buildShowItem");
	
	self.bg:addClickFuntion(self, self.selectdClick)
end

function Lua_NewFristRechargeCell:setData(data)
	self.redDot:setEnable(data == 2);
end

function Lua_NewFristRechargeCell:setIndex(index)
	self.cellIndex = index;
end

function Lua_NewFristRechargeCell:selectdClick()
	Lua_MsgUtil.callFunc("SET_SELECTED_BTN", self.cellIndex);
end

function Lua_NewFristRechargeCell:isSelecting(val)
	if val == true then
		self.bg:SetDimensions(220, 56);
		self.dayNumSp:SetDimensions(106, 36);
		self.dayNumSp:setLocation(-36, 3);
		self.giveSignSp:SetDimensions(64, 70);
		self.giveSignSp:setLocation(106, -6);
		self.giveLab:setLocation(113, -5);
		self.giveLab.fontSize = 20;
		self.redDot:setLocation(108, 26, 0);
	else
		self.bg:SetDimensions(176, 45);
		self.dayNumSp:SetDimensions(84, 28);
		self.dayNumSp:setLocation(-50, 3, 0);
		self.giveSignSp:SetDimensions(53, 58);
		self.giveSignSp:setLocation(68, -6);
		self.giveLab:setLocation(73, -2);
		self.giveLab.fontSize = 16;
		self.redDot:setLocation(85, 21, 0);
	end
end