Lua_RechargePanel = class("Lua_RechargePanel", Lua_DisplayObject);
function Lua_RechargePanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RechargePanel:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.rechargeData.winOpen = 1;

	Lua_MsgUtil.callFunc("CHONGZHI_REDDOT_POS", 10090);

	self.rechargeList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1048, 632));
	self.rechargeList:setLocation(108, -27, 0);
	self.rechargeList:setListCell(Lua_RechargeItem, 320, 262, 4);

	self:addLuaEvent("SET_RECHARGE_DATA", self, self.setRechargeData);
	DataCenter.rechargeData:sRechargeGiftBagMsg();
	DataCenter.rechargeData:sRechargeMagicBagMsg();
	DataCenter.rechargeData:sGetRechargeInfo();
end

function Lua_RechargePanel:setRechargeData()
	self.rechargeList:setLuaArrayData(DataCenter.rechargeData:rechargeInfoArr(), false);
end

function Lua_RechargePanel:dispose()	
	if self.rechargeList ~= nil then
		self.rechargeList:dispose()
		self.rechargeList = nil;
	end
	DataCenter.rechargeData.winOpen = 0;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeItem = class("Lua_RechargeItem", Lua_ListCell);
function Lua_RechargeItem:ctor(p)
	self:superCall("ctor", p, "VipRechargeItem_skin");
end

function Lua_RechargeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.giftBtn:addClickFuntion(self, self.onGiftBtnClick);
	self.rewardBtn:addClickFuntion(self, self.onRewardBtnBtnClick);
	self.magicBtn:addClickFuntion(self, self.onMagicBtnClick);
	self.chargeBtn:addClickFuntion(self, self.onChargeBtnClick);
end

function Lua_RechargeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.isShowGiftBag then -- 礼金礼包
		self.rechargeObj:SetActive(false);
		self.magicObj:SetActive(false);
		self.giftObj:SetActive(true);

		local curDay = DataCenter.rechargeData.activateCurDay; -- 每天可领取礼金
		local amountDayNum = DataCenter.rechargeData.amountDayNum; -- 礼包持续天数
		self.giftDesLab.text = LanUtil.formateStr(LanUtil.getValue(122581), tostring(curDay), tostring(amountDayNum));

		local activateState = DataCenter.rechargeData.activateState; -- 激活状态：1 已激活
		local receiveState = DataCenter.rechargeData.receiveState; -- 领取状态：1 已领取
		self.rechargeMoney = DataCenter.rechargeData.activateMoney; -- 礼包开启金额
		if activateState ~= 1 then
			local str;
			if getLanType() == 1 then
				str = Lua_CommonUtil.transMoney(math.floor(self.rechargeMoney));
			elseif getLanType() == 2 then
				str = tostring(self.rechargeMoney);
			else
				str = tostring(math.floor(self.rechargeMoney));
			end
			self.giftBtn.label = LanUtil.formateStr(LanUtil.getValue(121317), str);
		end
		self.giftBtn:setEnable(activateState ~= 1);
		self.rewardBtn:setEnable(activateState == 1 and receiveState ~= 1);
		self:showRedDot(activateState == 1 and receiveState ~= 1);
	elseif data.isShowMagicBag then -- 暴击法宝礼包
		self.rechargeObj:SetActive(false);
		self.giftObj:SetActive(false);
		self.magicObj:SetActive(true);
		self.magicTimeLab.text = LanUtil.getValue(122591);
		self.magicMoney =  DataCenter.rechargeData.openMagicBagMoney; -- 礼包开启金额
		self.giftMagicState = DataCenter.rechargeData.giftMagicState; -- 0可购买，1可领取，2已领取
		if self.giftMagicState == 0 then
			local str;
			if getLanType() == 1 then
				str = Lua_CommonUtil.transMoney(math.floor(self.magicMoney));
			elseif getLanType() == 2 then
				str = tostring(self.magicMoney);
			else
				str = tostring(math.floor(self.magicMoney));
			end
			self.magicBtn.label = LanUtil.formateStr(LanUtil.getValue(121317), str)
		elseif self.giftMagicState == 1 then
			self.magicBtn.label = LanUtil.getValue(122527);
		else
			self.magicBtn.label = LanUtil.getValue(122528);
		end
		self.magicBtn:setBtnEnable(self.giftMagicState ~= 2);
		self:showRedDot(self.giftMagicState == 1);
	else
		self.rechargeObj:SetActive(true);
		self.giftObj:SetActive(false);
		self.magicObj:SetActive(false);
		self:showRedDot(false);
		
		self.rewardLab.text = LanUtil.formateStr(LanUtil.getValue(121315), tostring(math.floor(data.glodNum)));

		local str;
		if getLanType() == 1 then
			str = Lua_CommonUtil.transMoney(math.floor(data.money));
		elseif getLanType() == 2 then
			str = tostring(data.money);
		else
			str = tostring(math.floor(data.money));
		end
		self.chargeBtn.label = LanUtil.formateStr(LanUtil.getValue(121317), str);

		if data.glodReward ~= 0 then
			self.getMoneyLab.text = math.floor(data.glodReward);
		else
			self.getMoneyLab.text = math.floor(data.bindGoldReward);
		end
		local addWidth = self.getMoneyLab.width - 24;
		self.moneyIcon:setLocation(79 - addWidth / 2, -60);
		self.getMoneyLab:setLocation(103 + addWidth / 2, -60);

		self.firstRewardObj:SetActive(true);
		self.rechargeIcon:setAltas(data.atlas,data.sprite);
		for k,v in ipairs(DataCenter.rechargeData.fist_recharge) do
			if tonumber(v) == math.floor(data.glodNum) then
				self.firstRewardObj:SetActive(false);
				self.rechargeIcon:setLocation(0, 8, 0);
			end
		end
	end
end

function Lua_RechargeItem:onGiftBtnClick()
	if DataCenter.roleData.limit == 1 then
		OperateAlert.show(LanUtil.getValue(122592));
		return;
	end
	DataCenter.sdkInterface:PointOut(0, tonumber(self.rechargeMoney), DataCenter.rechargeData.activateRechargeId);
end

function Lua_RechargeItem:onRewardBtnBtnClick()
	DataCenter.rechargeData:sReceiveGiftBagRewardMsg();
end

function Lua_RechargeItem:onMagicBtnClick()
	if DataCenter.roleData.limit == 1 then
		OperateAlert.show(LanUtil.getValue(122592));
		return;
	end

	if self.giftMagicState == 0 then
		Lua_WindowUtil.openWin("Lua_MagicBagTipsWindow",WinParam.ACTION_OPEN,self.magicMoney);
	elseif self.giftMagicState == 1 then
		DataCenter.rechargeData:sReceiveMagicBagRewardMsg();
	end
end

function Lua_RechargeItem:onChargeBtnClick()
	if DataCenter.roleData.limit == 1 then
		OperateAlert.show(LanUtil.getValue(122592));
		return;
	end
	DataCenter.sdkInterface:PointOut(self._data.glodNum, self._data.money);
end

function Lua_RechargeItem:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 113, 139, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(10);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_RechargeItem:dispose()
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end