Lua_RenewalsWindow = class("Lua_RenewalsWindow", Lua_ThirdSizeWindow)
function Lua_RenewalsWindow:ctor()
	self:superCall("ctor");
	self.w = 600;
	self.h = 406;
	self.windowName = "Lua_RenewalsWindow";
	self.skinName = "RenewalsWindow_skin";
	self.titleText = "續費"
end

function Lua_RenewalsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg:SetDimensions(604, 406);
	self.winBg:setLocation(0, -25);
	self.VipTypeInfoList = Lua_DragList.new(self.content,1, Vector4(-909, -35, 560, 346));
	self.VipTypeInfoList:setLocation(909, -12, 0);
	self.VipTypeInfoList:setListCell(Lua_RenewalsVipItem, 109, 559 , 1);

	self.vipTypeInfo = DataCenter.vipData:getAllVipTypeList()
	self.vipTypeInfo:remove(4)
	self.VipTypeInfoList:setLuaArrayData(self.vipTypeInfo, false);
end

function Lua_RenewalsWindow:dispose()
	if self.VipTypeInfoList ~= nil then
		self.VipTypeInfoList:dispose();
		self.VipTypeInfoList = nil;
	end
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_RenewalsVipItem = class("Lua_RenewalsVipItem", Lua_ListCell);
function Lua_RenewalsVipItem:ctor(p)
	self:superCall("ctor", p, "RenewalsVipItem_skin");
end

function Lua_RenewalsVipItem:buildShowItem()
	self:superCall("buildShowItem");

	self.stage_property = Lua_ToolImage.new(self.content);
	self.stage_property:setDepth(6);
	self.stage_property:setLocation(-212, 0);

	self.renewalsBtn:addClickFuntion(self, self.onRenewalsClick);
end

function Lua_RenewalsVipItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.id == 2 then
		self.cardTypesTxt.text =  "[00a10f]" .. data.name .. "[-]";
		self.stage_property.data = Lua_ToolVo.new(tonumber(202000042))
	elseif data.id == 3 then
		self.cardTypesTxt.text =  "[d900d6]" .. data.name .. "[-]";
		self.stage_property.data = Lua_ToolVo.new(tonumber(202000043))
	elseif data.id == 4 then
		self.cardTypesTxt.text =  "[ed9700]" .. data.name .. "[-]";
		self.stage_property.data = Lua_ToolVo.new(tonumber(202000044))
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_red_box","gui_red_box", -212, 0);
		self.effect:SetRenderQueue(self.cardTypesTxt, 5, 2);
		self.effect:setSacle(0.9,0.9,0.9);
	end

	self.needMoneyTxt.text = LanUtil.getValue(121306) .. data.gold;
end

function Lua_RenewalsVipItem:onRenewalsClick(go)
	DataCenter.vipData:sBuyVip(self.data.id)
end

function Lua_RenewalsVipItem:dispose()
	if self.stage_property ~= nil then
		self.stage_property:dispose();
		self.stage_property = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end