checkRequire("Lua_vipTypeTxtItem");
Lua_VIPPrivilegeWindow = class("Lua_VIPPrivilegeWindow", Lua_Window);
function Lua_VIPPrivilegeWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_VIPPrivilegeWindow";
	self.skinName = "PrivilegeWindow_skin";
	self.lastSendTime = 0;
end

function Lua_VIPPrivilegeWindow:showWin(param)
	self:superCall("showWin", param);

	self.vipTypeDragContainer = Lua_DragContainer.new(self.content,1, Vector4(325, -236, 668, 496));
	self.vipTypeDragContainer:setLocation(-475.5, 221, 0);
	self.vipTypeDragContainer.uiPanel.depth = 3000;
	self.draggableVipTypePanel = Lua_vipTypeDragPanel.new(self.vipTypeDragContainer.sub);
	self.vipTypeDragContainer:addSubContainer(self.draggableVipTypePanel, false);	

    self.draggableVipTypePanel:getTypeById(param.id);
    self.vipTypeDragContainer:updateChildPos();
end
--------------------------------------------------------------------------------------------------
-- vip卡片信息拖动框
Lua_vipTypeDragPanel = class("Lua_vipTypeDragPanel", Lua_DragContainerItem);
function Lua_vipTypeDragPanel:ctor(sub)
	self:superCall("ctor", sub, nil);

end

function Lua_vipTypeDragPanel:getHeight()
    return self._height;
end

function Lua_vipTypeDragPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self._height = 0;
	self.txtArr = Array();
end

function Lua_vipTypeDragPanel:getTypeById(vipId)
	self._height = 0;
	local vo = DataCenter.vipData:getVoById(vipId);
	if vo == nil then
		return;
	end

	local item;
	local count = table.getn(vo.privilege);
	local num = count - self.txtArr:getSize();
	while (num > 0) do
		item = Lua_vipTypeTxtItem.new(self.content, "VipTypeDrag_skin");
		item.pointImg:setAltas("common_atlas_2", "ui_common_widget_q1");
		item.pointImg:resetSize();
		item.listNum.text = count - num + 1;
		self.txtArr:add(item);
		num = num - 1;
	end

	while (num < 0) do
		item = self.txtArr:shift();
		item:dispose();
		num = num + 1;
	end

	for i = 1, count do
		item = self.txtArr[i];
		item:setText(vo.privilege[i]);
		item:setLocation(0, -self._height, 0);
		self._height = self._height + item:getHeight() + 23;
	end
end

function Lua_vipTypeDragPanel:dispose()
	if self.txtArr ~= nil then
		while (self.txtArr:getSize() > 0) do
			item = self.txtArr:shift();
			item:dispose();
		end
		self.txtArr:clear();
		self.txtArr = nil;
	end

	self:superCall("dispose");
end
