﻿checkRequire("Lua_VipTypeItem");
checkRequire("Lua_DailyRewardItem");
checkRequire("Lua_vipTypeTxtItem");
Lua_VipPanel = class("Lua_VipPanel", Lua_DisplayObject);
function Lua_VipPanel:ctor(p)
	self:superCall("ctor", p, "VipPanel_skin");
end

function Lua_VipPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_MsgUtil.callFunc("CHONGZHI_REDDOT_POS", 10097);

	self.remarkTxt.text = LanUtil.getValue(121308);
	self.curID = 0;
	self.curModelIndex = DataCenter.vipData.level + 1;
	
	self.redDot:setEnable(false);
	self.hongdain1:setEnable(false);
	self.notOpenBoard:SetActive(false);
	self.openedBoard:SetActive(false);

	self.VipTypeInfoList = Lua_DragList.new(self.notOpenBoard, 1, Vector4(0, 0, 288, 500));
	self.VipTypeInfoList:setListCell(Lua_VipTypeItem, 118, 288, 1);
	self.VipTypeInfoList:setLocation(476, 35, 0);

	self.dailyValue = Lua_NumberImage.new(self.notOpenBoard); -- 每日礼包价值
	self.dailyValue.numWidth = 20;
	self.dailyValue.prefix = "ui_chongzhi_a_";
	self.dailyValue.pivot = 2;
	self.dailyValue:setDepth(6);
	self.dailyValue:setLocation(223, -109, 0);

	local icon;
	self.greenList = {};
	for i = 1, 4 do
		icon = UICreate.createUIAtlasImage(self.classAObj, "common_atlas_1", "ui_common_b_1", 60.5, -218 - (i - 1) * 30, 0, 0);
		icon:setDepth(6);
		self.greenList[i] = icon;
	end

	self.titleANum = Lua_NumberImage.new(self.classAObj); -- A称号威力
	self.titleANum.numWidth = 12;
	self.titleANum.prefix = "";
	self.titleANum:setDepth(6);
	self.titleANum:setLocation(-74, -318, 0);

	self.expNum = Lua_NumberImage.new(self.classAObj); -- 经验加成
	self.expNum.numWidth = 18;
	self.expNum.prefix = "ui_chongzhi_b_";
	self.expNum:setDepth(1);
	self.expNum:setLocation(-300, 157, 0);

	self.vipRewardLevel = Lua_NumberImage.new(self.viptitletipsA); -- VIP奖励等级
	self.vipRewardLevel.prefix = "ui_chongzhi_vip_";
	self.vipRewardLevel:setDepth(6);
	self.vipRewardLevel:setLocation(-220, 245, 0);

	self.vipInfoDragContainer = Lua_DragContainer.new(self.openedBoard, 1, Vector4(235, -165, 500, 355));
	self.vipInfoDragContainer:setLocation(-278, 49, 0);
	self.draggableVipInfoPanel = Lua_vipInfoDragPanel.new(self.vipInfoDragContainer.sub);
	self.vipInfoDragContainer:addSubContainer(self.draggableVipInfoPanel, false);

	local curVipLv = DataCenter.vipData.level;
	self.levelNum = Lua_NumberImage.new(self.openedBoard);
	self.levelNum.numWidth = 12;
	self.levelNum.prefix = "ui_chongzhi_vip";
	self.levelNum.num = curVipLv;
	self.levelNum:setDepth(4);
	self.levelNum:setLocation(-329, 231, 0);

	self.vipLevelInfo = DataCenter.vipData:getTheWholeVipLevelList();
	self.vipTypeInfo = DataCenter.vipData:getAllVipTypeList();
	local initIndex = 1;
	local len = self.vipTypeInfo:getSize();
	local winData = DataCenter.vipData.ChongzhiWindowData;
	if type(winData) == "table" then     
		if winData ~= nil and winData.nameIndex ~= nil then  
			for i = 1, len do
				if self.vipTypeInfo[i].name == LanUtil.getValue(winData.nameIndex) then
					initIndex = i;
					break;
				end
			end
		end
	end

	if len > 0 then
		self:setSelected(self.vipTypeInfo[initIndex]);
	end

	if curVipLv ~= 100 then
		self:showOpenedBoardIn_CurModule(curVipLv + 1);
	end

	self.hyperlink.text = "[u]"..LanUtil.getValue(127905).."[/u]"; 
	self.hyperlink.clickScale = false;
	self.hyperlink:addClickFuntion(self, self.onhyperlinkClick);

	self.renewalsBtn:addClickFuntion(self, self.onRenewalsClick);
	self.prevBtn:addClickFuntion(self, self.onPrevClick);
	self.nextBtn:addClickFuntion(self, self.onNextClick);
	self.buyBtn:addClickFuntion(self, self.onGetClick);
	self.gifts:addClickFuntion(self, self.onGiftClick);
	self.kaitongBtn:addClickFuntion(self, self.onKaitongClick);
	
	Lua_MsgUtil.callFunc("HIDE_VIP_ICON_REDDOT", false);

	self:addLuaEvent("VIP_TYPEINFO_CLICK", self, self.setSelected);
	self:addLuaEvent("VIP_GET_ROLE_VIPINFORMATION", self, self.getRoleVipInfo);
	DataCenter.vipData:sGetRoleVipInfo();
end

function Lua_VipPanel:getRoleVipInfo(obj)
	if obj == nil then
		return;
	end
	self.expired_time = obj.expired_time;

	local surplusTime = tonumber(obj.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
	self.notOpenBoard:SetActive(surplusTime <= 0 or obj.vip_type == 1 or obj.vip_type == 5);
	self.openedBoard:SetActive(surplusTime > 0 and obj.vip_type ~= 1 and obj.vip_type ~= 5);

	self.curID = obj.level + 1
	if obj.level < self.vipLevelInfo:getSize() - 2 then
		if self.curID > 1 then
			self.vipExpBar:setText(obj.cur_exp.."/"..self.vipLevelInfo[self.curID].need_exp);
			self.vipExpBar:setMaxValue(self.vipLevelInfo[self.curID].need_exp);
			self.vipExpBar:setValue(obj.cur_exp);
		end
	else
		self.vipExpBar:setText(LanUtil.getValue(121311));
		self.vipExpBar:setMaxValue(1);
		self.vipExpBar:setValue(1);
	end

	self.curTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(121309), TimeTransform.getInstance():transSeconds1(surplusTime, true));
	self:startTimer();
	self:onTimeStrTimer();

	if obj.vip_type ~= 5 and obj.vip_type ~= 1 then
		self:showOpenedBoardIn_CurModule(obj.level + 1);
	end
	self:setSelected(self.data);
	self.curModelIndex = obj.level + 1;
	self.levelNum.num = obj.level;
end

function Lua_VipPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_VipPanel", 1, self, self.onTimeStrTimer);
	end
end

function Lua_VipPanel:onTimeStrTimer()
	local surplusTime = tonumber(self.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
	self.curTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(121309), TimeTransform.getInstance():transSeconds1(surplusTime,true))
	if surplusTime <= 0 then
		self:endTimer();
	end
end

function Lua_VipPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_VipPanel:showOpenedBoardIn_CurModule(vipLv)
	self:setSwitchBtn(vipLv);
	self.index = vipLv - 1;

	local name = getConfig({"vip_level", vipLv - 1, "view_name"});
	self.viptitleLab.text =  LanUtil.formateStr(LanUtil.getValue(121324), name);
	self.privilegeTxt.text = LanUtil.formateStr(LanUtil.getValue(121310), name);

	self.draggableVipInfoPanel:getInfoByIndex(vipLv - 1);
	self.vipInfoDragContainer:updateChildPos();

	local daily_gift;
	if vipLv - 1 >= 1 then
		if DataCenter.roleData.worldLevel <= self.vipLevelInfo[vipLv].daily_gift[1][2] then
			daily_gift = self.vipLevelInfo[vipLv].daily_gift[1][3];
			self.moneyLab.text = self.vipLevelInfo[vipLv].daily_gift_cost[1];
		else
			daily_gift = self.vipLevelInfo[vipLv].daily_gift[2][3];
			self.moneyLab.text = self.vipLevelInfo[vipLv].daily_gift_cost[2];
		end

		self:initRewardList();
		local rewardArr = DataCenter.vipData.rewardList(Array(daily_gift));
		self.rewardList:setLuaArrayData(rewardArr, false);
	end

	self.goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	if vipLv - 1 >= 1 then
		self.buyBtn:setEnable(vipLv - 1 == DataCenter.vipData.level and DataCenter.vipData.gift_state == 1);
		self.redDot:setEnable(vipLv - 1 == DataCenter.vipData.level and DataCenter.vipData.gift_state == 1);
		self.drawIcon:setEnable(vipLv - 1 == DataCenter.vipData.level and DataCenter.vipData.gift_state == 2);
	end
end

function Lua_VipPanel:setSwitchBtn(index)
	local maxLen = self.vipLevelInfo.getSize();
	if index <= 2 then
		self.prevBtn.mouseEnable = false;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_02";

		self.nextBtn.mouseEnable = true;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_01";
	elseif index >= maxLen - 1 then
		self.prevBtn.mouseEnable = true;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_01";

		self.nextBtn.mouseEnable = false;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_02";
	else
		self.nextBtn.mouseEnable = true;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_01";

		self.prevBtn.mouseEnable = true;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_01";
	end
end

function Lua_VipPanel:initRewardList()
	if self.rewardList == nil then
		self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 220, 250));
		self.rewardList:setLocation(363, -45, 0);
		self.rewardList:setListCell(Lua_DailyRewardItem, 90, 110, 2);
	end
end

function Lua_VipPanel:setSelected(val)
	self.data = val;
	for i = 1, self.vipTypeInfo:getSize() do
		self.vipTypeInfo[i].selected = self.vipTypeInfo[i].id == val.id; 
	end

	local vipCardNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(202000059);
	local str;
	if DataCenter.vipData.level ~= 100 then
		if vipCardNum ~= 0 then
			str = LanUtil.getValue(121327);
		else
			str = LanUtil.getValue(121326);
		end
	else
		str = LanUtil.getValue(121327);
	end
	self.vipTypeInfo[4].textStr = str;
	self.vipTypeInfo[4].isCanGet = DataCenter.vipData.gift_state == 1 and DataCenter.vipData.level == 100;
	self.VipTypeInfoList:setLuaArrayData(self.vipTypeInfo, false)

	self.selectGold = val.gold;
	self.VipLevel = val.level;
	self.selectedVipTypeId = val.id;
	self:notOpenBoardModuleInit(val);
end

function Lua_VipPanel:notOpenBoardModuleInit(val)
	self.kaitongBtn:setEnable(self.selectedVipTypeId ~= 5);

	local value;
	for i = 1, self.vipLevelInfo:getSize() do
		if val.level == self.vipLevelInfo[i].id then
			if DataCenter.roleData.worldLevel <= self.vipLevelInfo[i].daily_gift[1][2] then
				value = self.vipLevelInfo[i].daily_gift_cost[1];
			else
				value = self.vipLevelInfo[i].daily_gift_cost[2];
			end
		end
	end
	self.dailyValue.num = value;

	local tdata = Lua_TitleData.new(val.title);
	self.tilttips2.text = tdata.descNoColor;

	self.titleANum.num = val.titleforce;

	local deliverytipsStr;
	self.greenArr = Array();
	self.blueArr = Array();
	if val.deliverytips ~= nil then
		for k,v in ipairs(val.deliverytips) do
			if deliverytipsStr == nil then
				deliverytipsStr = "";
			else
				deliverytipsStr = deliverytipsStr.."\n";
			end
			deliverytipsStr = deliverytipsStr..v;
			
			self.greenArr:add(k);
			self.blueArr:add(k);
		end
	end
	self.tips2.text = deliverytipsStr;
	self.tips2B.text = deliverytipsStr;

	local greenLen = self.greenArr:getSize()  
	if #self.greenList > greenLen then   
		for i = #self.greenList, greenLen, -1 do
			if self.greenList[i] ~= nil and i > greenLen then
				self.greenList[i]:dispose();
				self.greenList[i] = nil;
			end
		end
	elseif #self.greenList < greenLen then
		local icon;
		for i = #self.greenList + 1, greenLen do
			icon = UICreate.createUIAtlasImage(self.classAObj, "common_atlas_1", "ui_common_b_1", 60.5, -218 - (i - 1) * 30, 0, 0);
			icon:setDepth(6);
			self.greenList[i] = icon;
		end
	end

	local blueLen = self.blueArr:getSize()
	if self.blue == nil then
		for i = 1, blueLen do
			self.blue = UICreate.createUIAtlasImage(self.classBObj, "common_atlas_1", "ui_common_b_1", -107, -216 - (i - 1) * 34, 0, 0);
			self.blue:setDepth(6);
		end
	end

	if self.selectedVipTypeId == 2 then -- 黄金
		self.classAObj:SetActive(true);
		self.classBObj:SetActive(false);

		self.viptitletipsA:SetActive(true);
		self.viptitletipsM:SetActive(false);

		self.vipInfoBg:setUrl("/images/recharge/ui_chongzhi_z_25.png");
		self.vipInfoBg:setLocation(-43, -32.5);
		self.vipInfoBg:SetDimensions(731, 629);

		self.titleA4:setAltas("recharge_atlas", "ui_chongzhi_z_03");
		self.titleA4:SetDimensions(80, 44);

		self.vipzcm:setUrl("/images/recharge/ui_chongzhi_icon_09.png");
		self.vipzcm:setLocation(-192, 12);
		self.vipzcm:SetDimensions(318, 252);

		self.expNum.num = 30;
		self.vipRewardLevel.num = 1;

		self.hongdain1:setEnable(false);

		self.viprank:setAltas("item7", tostring(val.title));
		self.viprank:resetSize();
	elseif self.selectedVipTypeId == 3 then -- 白金
		self.classAObj:SetActive(true);
		self.classBObj:SetActive(false);
		self.viptitletipsA:SetActive(true);
		self.viptitletipsM:SetActive(false);

		self.vipInfoBg:setUrl("/images/recharge/ui_chongzhi_z_23.png");
		self.vipInfoBg:setLocation(-43, -32.5);
		self.vipInfoBg:SetDimensions(731, 629);

		self.titleA4:setAltas("recharge_atlas", "ui_chongzhi_z_04");
		self.titleA4:SetDimensions(122, 44);

		self.vipzcm:setUrl("/images/recharge/ui_chongzhi_icon_04.png");
		self.vipzcm:setLocation(-200, 11);
		self.vipzcm:SetDimensions(306, 226);

		self.expNum.num = 30;
		self.vipRewardLevel.num = 2;

		self.hongdain1:setEnable(false);

		self.viprank:setAltas("item7", tostring(val.title));
		self.viprank:resetSize();
	elseif self.selectedVipTypeId == 4 then -- 黑金
		self.classAObj:SetActive(false);
		self.classBObj:SetActive(true);

		self.vipInfoBg:setUrl("/images/recharge/ui_chongzhi_z_14.png");
		self.vipInfoBg:setLocation(-44, -35);
		self.vipInfoBg:SetDimensions(732, 630);

		self.rank:setAltas("item7", tostring(val.title));
		self.rank:resetSize();

		self:effModel();

		self.carForce.num = val.model;
		self.weekCardValue.num = value;
		self.rankBForce.num = val.titleforce;
		self.weekCardValue:setNumScale(0.9, 0.9);
	elseif self.selectedVipTypeId == 5 then -- 会员
		self.classAObj:SetActive(true);
		self.classBObj:SetActive(false);
		self.viptitletipsA:SetActive(false);
		self.viptitletipsM:SetActive(true);

		self.vipInfoBg:setUrl("/images/recharge/ui_chongzhi_z_13.png");
		self.vipInfoBg:setLocation(-43, -32.5);
		self.vipInfoBg:SetDimensions(731, 629);

		self.hongdain1:setEnable(DataCenter.vipData.gift_state == 1 and DataCenter.vipData.level == 100);

		self.expNum.num = 10;

		self.viprank:setAltas("item7", tostring(val.title));
		self.viprank:resetSize();
	end
end

function Lua_VipPanel:effModel()
	if self.modelEffect == nil then
		local effectInfo = getConfig({"vip_const", "reward_item", "arr"});
		local modelInfo = getConfig({"item", effectInfo[1]});
		local shapeConfig = getConfig({"playerHanger", tonumber(modelInfo.tipShowModel)});

		self.modelEffect = UICreate.createUIEffect(self.classBObj, shapeConfig.floder.."/"..shapeConfig.fileName, tostring(shapeConfig.modelName), -205, -30);	
		self.modelEffect:SetRenderQueue(self.modeltitleforce, 5, 2, false);
		self.modelEffect:setRotEnable(true, -195, 40, 400, 250, 1);
		self.modelEffect:setSacle(150, 150, 150);
		self.modelEffect:setRot(0, -140, 0);  
	end

	if self.carForce == nil then
		self.carForce = Lua_NumberImage.new(self.classBObj); -- 车战力
		self.carForce.numWidth = 12;
		self.carForce:setDepth(6);
		self.carForce:setLocation(-78, -107, 0);
	end

	if self.rankBForce == nil then
		self.rankBForce = Lua_NumberImage.new(self.classBObj); -- B称号威力
		self.rankBForce.numWidth = 12;
		self.rankBForce:setDepth(6);
		self.rankBForce:setLocation(-225, -324, 0);
	end

	if self.weekCardValue == nil then
		self.weekCardValue = Lua_NumberImage.new(self.classBObj); -- B白送周卡
		self.weekCardValue.numWidth = 19;
		self.weekCardValue.prefix = "ui_chongzhi_a_";
		self.weekCardValue:setDepth(6);
		self.weekCardValue:setLocation(203, -324, 0);
	end
end

function Lua_VipPanel:onhyperlinkClick()
	if self.data.id == nil then
		self.data = self.vipTypeInfo[1];
	end
	Lua_WindowUtil.openWin("Lua_VIPPrivilegeWindow", WinParam.ACTION_OPEN, self.data);
end

function Lua_VipPanel:onRenewalsClick(go)
	Lua_WindowUtil.openWin("Lua_RenewalsWindow");
end

function Lua_VipPanel:onPrevClick(go)
	if self.vipLevelInfo ~= nil then
		if self.curModelIndex > 1 then
			self.curModelIndex = self.curModelIndex - 1;
		end
		self:showOpenedBoardIn_CurModule(self.curModelIndex);
	end
end

function Lua_VipPanel:onNextClick(go)
	if self.vipLevelInfo ~= nil then
		if self.curModelIndex < self.vipLevelInfo:getSize()-1 then
			self.curModelIndex = self.curModelIndex + 1;
		end
		self:showOpenedBoardIn_CurModule(self.curModelIndex);
	end
end

function Lua_VipPanel:onGetClick()
	DataCenter.vipData:sGetVipDailyPresent()
end

function Lua_VipPanel:onGiftClick(go)
	if DataCenter.vipData.gift_state == 1 and DataCenter.vipData.level == 100 then
		DataCenter.vipData:sGetVipDailyPresent()
	else
		local daily_gift = Array()
		for i = 1, self.vipLevelInfo:getSize() do   
			if self.VipLevel == self.vipLevelInfo[i].id then
				if DataCenter.roleData.worldLevel <= self.vipLevelInfo[i].daily_gift[1][2] then
					daily_gift:add(self.vipLevelInfo[i].daily_gift[1][3]);
				else
					daily_gift:add(self.vipLevelInfo[i].daily_gift[2][3]);
				end
			end
		end

		local dailyGiftArr = Array();
		dailyGiftArr:add(DataCenter.vipData.rewardList(daily_gift));
		dailyGiftArr:add(self.VipLevel);
		Lua_WindowUtil.openWin("Lua_VipGiftTipsWindow", WinParam.ACTION_OPEN, dailyGiftArr);
	end
end

function Lua_VipPanel:onKaitongClick(go)
	local goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	if self.selectGold <= goldNum then
		DataCenter.vipData:sBuyVip(self.selectedVipTypeId);
		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.onVipOpen);
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521),
			type = 1, subFun = self.openChargeWin});
	end
end

function Lua_VipPanel:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_VipPanel:dispose()
	if self.VipTypeInfoList ~= nil then
		self.VipTypeInfoList:dispose();
		self.VipTypeInfoList = nil;
	end
	if self.dailyValue ~= nil then
		self.dailyValue:dispose();
		self.dailyValue = nil;
	end
	if self.titleANum ~= nil then
		self.titleANum:dispose();
		self.titleANum = nil;
	end
	if self.expNum ~= nil then
		self.expNum:dispose();
		self.expNum = nil;
	end
	if self.vipRewardLevel ~= nil then
		self.vipRewardLevel:dispose();
		self.vipRewardLevel = nil;
	end
	if self.vipInfoDragContainer ~= nil then
		self.vipInfoDragContainer:dispose();
		self.vipInfoDragContainer = nil;
	end
	if self.draggableVipInfoPanel ~= nil then
		self.draggableVipInfoPanel:dispose();
		self.draggableVipInfoPanel = nil;
	end
	if self.levelNum ~= nil then
		self.levelNum:dispose();
		self.levelNum = nil;
	end
	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end
	if self.carForce ~= nil then
		self.carForce:dispose();
		self.carForce = nil;
	end
	if self.rankBForce ~= nil then
		self.rankBForce:dispose();
		self.rankBForce = nil;
	end
	if self.weekCardValue ~= nil then
		self.weekCardValue:dispose();
		self.weekCardValue = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_vipInfoDragPanel = class("Lua_vipInfoDragPanel", Lua_DragContainerItem);
function Lua_vipInfoDragPanel:ctor(sub)
	self:superCall("ctor", sub);
end

function Lua_vipInfoDragPanel:buildShowItem()
	self:superCall("buildShowItem");

	self._height = 0;
	self.txtArr = Array();
	self.vipLevelInfo = DataCenter.vipData:getTheWholeVipLevelList()
end

function Lua_vipInfoDragPanel:getInfoByIndex(lv)
	local count = 0;
	local id = lv + 1;
	if id > 1 then
		count = table.getn(self.vipLevelInfo[id].des)
	end

	local item;
	local num = count - self.txtArr:getSize();
	while(num > 0) do
		item = Lua_vipTypeTxtItem.new(self.content, "VipTypeDrag_skin");
		self.txtArr:add(item);
		num = num - 1;
	end

	while(num < 0) do
		item = self.txtArr:shift();
		item:dispose();
		num = num + 1;
	end

	self._height = 0;
	for i = 1, count do
		item = self.txtArr[i];
		item:setText(self.vipLevelInfo[id].des[i]);
		item:setLocation(0, -self._height, 0);
		self._height = self._height + item:getHeight() + 10;
	end
end

function Lua_vipInfoDragPanel:getHeight()
	return self._height;
end

function Lua_vipInfoDragPanel:dispose()
	if self.txtArr ~= nil then
		while(self.txtArr:getSize() > 0) do
			item = self.txtArr:shift();
			item:dispose();
		end
		self.txtArr:clear();
		self.txtArr = nil;
	end

	self:superCall("dispose");
end