checkRequire("Lua_WeeklyCardData");
Lua_WeeklyCardPanel = class("Lua_WeeklyCardPanel", Lua_DisplayObject);
function Lua_WeeklyCardPanel:ctor(p)
	self:superCall("ctor", p, "WeeklyCardPlan_skin");
end

function Lua_WeeklyCardPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_MsgUtil.callFunc("CHONGZHI_REDDOT_POS", 10143);

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 977, 379));
	self.rewardList:setLocation(98, -114, 0);
	self.rewardList:setListCell(Lua_WeeklyCardItem, 129, 990, 1);

	self.tipsLab.text = LanUtil.getValue(122526);

	self.investmentBtn:addClickFuntion(self, self.buyClick);
	self:addLuaEvent("WEEKLYCARD_UPDATE", self, self.updateWeeklyCard);
	sendMsg(11403310);
end

function Lua_WeeklyCardPanel:updateWeeklyCard()
	local weeklyCardData = DataCenter.weeklyCardData;
	weeklyCardData:updateWeeklyCardData();
	self.desLab.text = LanUtil.formateStr(LanUtil.getValue(127903), weeklyCardData.subunitLen);

	local sortIdx;
	local arr = Array();
	for i = 1, #weeklyCardData.reward do
		if weeklyCardData.receive_map[i].obj_value == 2 then
			sortIdx = 100 - i;
		else
			sortIdx = 5000 - i;
		end
		arr:add({index = i, reward = weeklyCardData.reward[i], value = weeklyCardData.receive_map[i].obj_value,
			sub_group_index = weeklyCardData.sub_group_index, sortIdx = sortIdx});
	end
	arr:sort("sortIdx",true);
	self.rewardList:setLuaArrayData(arr, false);

	self.state = weeklyCardData.state;
	if self.state == 2 then
		self.investmentBtn.label = LanUtil.getValue(127900); 
	elseif self.state == 1 then
		self.investmentBtn.label = LanUtil.getValue(127406); 
	else
		self.investmentBtn.label = LanUtil.formateStr(LanUtil.getValue(127901), tostring(weeklyCardData.cost_money)); 
	end
	self.investmentBtn:setBtnEnable(self.state ~= 1);
end

function Lua_WeeklyCardPanel:buyClick()
	if self.state == 2 then
		Lua_WindowUtil.openWin("Lua_WeeklyCardEnterCheckVipTips");
	end

	if self.state == 0 then
		sendMsg(11403312);
	end
end

function Lua_WeeklyCardPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_WeeklyCardItem = class("Lua_WeeklyCardItem", Lua_ListCell);
function Lua_WeeklyCardItem:ctor(p)
	self:superCall("ctor", p, "WeekItem_skin");
end

function Lua_WeeklyCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(6);
	self.rItem:setLayout(90, 90, 6);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(-342.5, 8.5, 0);

	self.receiveBtn:addClickFuntion(self, self.onReceiveClick);
end

function Lua_WeeklyCardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.desLab.text = LanUtil.formateStr(LanUtil.getValue(127904), tostring(data.sub_group_index + 1), tostring(data.index));

	local tvo;
	local rewardArr = Array();
	for k,v in ipairs(data.reward) do
		tvo = Lua_ToolVo.createToolVo(v[1], v[2], v[3]);
		rewardArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardArr);

	if data.value == 0 then
		self.receiveBtn.label = LanUtil.getValue(122516);
		self.receiveBtn:setStyle(33);
	elseif  data.value == 1 then
		self.receiveBtn.label = LanUtil.getValue(122516);
		self.receiveBtn:setStyle(16);
	else
		self.receiveBtn.label = LanUtil.getValue(122528);
		self.receiveBtn:setStyle(33);
	end
	self.receiveBtn:setBtnEnable(data.value == 1);
	self.redDot:setEnable(data.value == 1);
end

function Lua_WeeklyCardItem:onReceiveClick()
	local cmd = ProtoPublic_pb.Proto11403311();
	cmd.reward_day = self._data.index - 1;
	sendMsg(11403311, cmd);
end

function Lua_WeeklyCardItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end